#include "deu.h"
#include "levels.h"

#define REDRAW_NONE			0
#define REDRAW_QUICK		1
#define REDRAW_ALL			2
#define REDRAW_INFO			3


BCINT MaxY;
BCINT sd1x;
BCINT sd1y;
BCINT sd2x;
BCINT sd2y;

void GetCoords()
{
	if (InfoShown)
		MaxY = ScrMaxY;
	else
		MaxY = ScrMaxY + 13;
	sd1x = ScrMaxX - 140;
	sd1y = ScrMaxY - 266;
	sd2x = ScrMaxX - 72;
	sd2y = ScrMaxY - 266;
	if (VideoMode < 3) {
		sd1y -= 91;
		sd2y -= 91;
	}
	if (InfoShown) {
		sd1y -= 13;
		sd2y -= 13;
	}
}

/*******************/
/* THING FUNCTIONS */
/*******************/

BCINT FunctionThingFlag(BCINT CurObject, SelPtr Selected, BCINT Flag)
{
	SelPtr cur;

	Backup (BTHINGS);
	strcpy (BackupText, "Change Thing Flags");
	for (cur = Selected; cur; cur = cur->next)
		if(cur->objnum != CurObject)  
			Things[ cur->objnum].flags ^= 1 << (Flag - 1);
	if (CurObject >= 0) 
		Things[ CurObject].flags ^= 1 << (Flag - 1);
	MadeChanges = TRUE;
	return REDRAW_INFO;
}

BCINT FunctionThingTID(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;
	Bool polything;

	GetCoords();
	if (CurObject >= 0)
		polything = GetThingExtra (Things[CurObject].type) & TX_POLYSPOT;
	else
		polything = GetThingExtra (Things[Selected->objnum].type) & TX_POLYSPOT;

	if (polything)
	{	// edit the polyobject ID
		if (CurObject >= 0)
			val = InputIntegerValuePlain(90, MaxY - 86, 0, 255, Things[CurObject].angle);
		else
			val = InputIntegerValue( -1, -1, 0, 255, Things[Selected->objnum].angle);
		if (val >= 0)
		{
			Backup (BTHINGS);
			strcpy (BackupText, "Change Thing Poly ID");
			for(cur = Selected; cur; cur = cur->next) 
				if(cur->objnum != CurObject)  
					Things[cur->objnum].angle = val;
			MadeChanges = TRUE;
			if (CurObject >= 0)
			{
				Things[ CurObject].angle = val;
				return REDRAW_ALL;
			}
		}
	}
	else
	{	// edit the thing ID
		if (CurObject >= 0)
			val = InputIntegerValuePlain(90, MaxY - 86, 0, 255, Things[ CurObject].tid);
		else
			val = InputIntegerValue( -1, -1, 0, 32767, Things[ Selected->objnum].tid);
		if (val >= 0)
		{
			Backup (BTHINGS);
			strcpy (BackupText, "Change Thing TID");
			for(cur = Selected; cur; cur = cur->next) 
				if(cur->objnum != CurObject)  
					SetThingTID (cur->objnum, val);
			MadeChanges = TRUE;
			if (CurObject >= 0)
			{
				SetThingTID (CurObject, val);
				return REDRAW_ALL;
			}
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionThingDeathScript(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur = Selected;
	int val = -1;

	GetCoords();
	if (CurObject >= 0)
		val = InputIntegerValuePlain(90, MaxY - 76, 0, 255, Things[ CurObject].special);
	else
		val = InputIntegerValue(-1, -1, 0, 255, Things[cur->objnum].special);
	if (val >= 0) {
		strcpy (BackupText, "Change Thing Death Script");
		for (cur = Selected; cur; cur = cur->next)
			if (cur->objnum != CurObject)
				Things[cur->objnum].special = val;
		if (CurObject >= 0)
			Things[CurObject].special = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingSpecial(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	ld_class *c;
	ld_type *t;
	char *menuarr[MENUARRAYMAX];
	BCINT dummy[MENUARRAYMAX];
	int val, i;
	Bool input_integer = FALSE;
	
	c = Linedef_classes;
	for(i = 0; (c && i < MENUARRAYMAX-2); i++) {
		menuarr[i] = c->name;
		c = c->next;
	}
	menuarr[i++] = "-";
	menuarr[i++] = "Enter a Decimal Value";
	
	val = DisplayMenuArray( -1, -1, "Choose a Special Class:",
						   i, NULL, menuarr, dummy);
	if(val == 0)
		val = -1;
	
	if(i == val) {
		input_integer = TRUE;
		val = InputIntegerValue(-1, -1, 0, 255, 0);
	}
	
	if(val >= 0) {
		if(!input_integer) {
			c = Linedef_classes;
			while(--val)
				c = c->next;
			/* now c points to the class we are
			   going to display a submenu for */
			
			t = c->types;
			for(i = 0; (t && i < MENUARRAYMAX); t = t->next) {
				menuarr[i++] = t->longname;
			}
			
			if(i == 1) {
				val = c->types->type; 
				strcpy (BackupText, "Change Special Type");
				Backup (BTHINGS);
				for (cur = Selected; cur; cur = cur->next) {
					if(cur->objnum != CurObject) 
						Things[ cur->objnum].special = val;
				}
				if (CurObject >= 0)
					Things[ CurObject].special = val;
				MadeChanges = TRUE;
			}
			else {
				val = DisplayMenuArray(-1, -1, "Choose a Special Type:",
									   i, NULL, menuarr, dummy);
				if(val == 0)
					val = -1;
			}
		}
		
		if (i >= 2 && val >= 0) {
			strcpy (BackupText, "Change Special Type");
			Backup (BTHINGS);
			if(!input_integer) {
				t = c->types;
				while(--val)
					t = t->next;
				val = t->type;
			}
			
			for (cur = Selected; cur; cur = cur->next) {
				if(cur->objnum != CurObject)  
					Things[ cur->objnum].special = val;
			}
			if (CurObject >= 0)
				Things[ CurObject].special = val;
			MadeChanges = TRUE;
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionThingZPos(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	val = InputIntegerValue( -1, -1, -32767, 32767, Things[ Selected->objnum].zpos);
	if (val >= -32767)
	{
		strcpy (BackupText, "Change Thing Z Position");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].zpos = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingEnum(BCINT CurObject, SelPtr Selected, BCINT Arg, char *enumName)
{
	SelPtr cur;
	int val;

	val = SelectEnumValue(enumName);
	if (val >= 0)
	{
		sprintf (BackupText, "Change Thing %s Value", enumName);
		for (cur = Selected; cur; cur = cur->next)
			Things[cur->objnum].arg[Arg-1] = val;
		if (CurObject >= 0)
			Things[ CurObject].arg[Arg-1] = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingArgFlags(BCINT CurObject, SelPtr Selected, BCINT Arg, char *flagsName)
{
	enum_type *e = FindEnum (flagsName);
	char title[100];
	SelPtr cur;
	int val, mask;

	if (e == NULL)
	{
		return FunctionThingArg (CurObject, Selected, Arg);
	}

	if (CurObject >= 0)
		val = Things[CurObject].arg[--Arg];
	else
		val = Things[Selected->objnum].arg[--Arg];

	sprintf (title, "Toggle %s Flags:", flagsName);
	val = TwiddleFlagsMenu (e->keys, title, val, &mask);
	if (mask == 0)
	{ // Set directly
		sprintf (BackupText, "Set Thing %s Flags", flagsName);
		val &= 255;
		for (cur = Selected; cur; cur = cur->next) 
			Things[ cur->objnum].arg[Arg] = val;
		if (CurObject >= 0)
			Things[ CurObject].arg[Arg] = val;
	}
	else if (val != 0 || mask != ~0)
	{ // xor with existing flags
		sprintf (BackupText, "Change Thing %s Flags", flagsName);
		for (cur = Selected; cur; cur = cur->next) 
			if(cur->objnum != CurObject)  
				Things[ cur->objnum].arg[Arg] = (Things[ cur->objnum].arg[Arg] & mask) ^ val;
		if (CurObject >= 0)
			Things[ CurObject].arg[Arg] = (Things[ CurObject].arg[Arg] & mask) ^ val;
	}
	MadeChanges = (val != 0 || mask != ~0);
	return REDRAW_ALL;
}

BCINT FunctionThingHexenAngle(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur;
	int val;

	val = SelectHexenAngle();
	if (val >= 0)
	{
		strcpy (BackupText, "Change Thing Angle Argument");
		for (cur = Selected; cur; cur = cur->next)
			Things[cur->objnum].arg[Arg-1] = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingNegative(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur;
	int val;

	val = SelectNegative();
	if (val >= 0)
	{
		strcpy (BackupText, "Change Thing Yes/No Argument");
		for (cur = Selected; cur; cur = cur->next)
			Things[cur->objnum].arg[Arg-1] = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingSpawnType(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur;
	int val;

	ShowSprite = TRUE;
	val = SelectSpawnType();
	ShowSprite = FALSE;
	if (val >= 0)
	{
		strcpy (BackupText, "Change Thing Spawn Type");
		for (cur = Selected; cur; cur = cur->next)
			Things[cur->objnum].arg[Arg-1] = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingArg(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur = Selected;
	int val = -1;

	GetCoords();
	if (CurObject >= 0)
		val = InputIntegerValuePlain(90, MaxY - 76 + 10*Arg, 0, 255, Things[ CurObject].arg[Arg-1]);
	else
		val = InputIntegerValue(-1, -1, 0, 255, Things[cur->objnum].arg[Arg-1]);
	if (val >= 0)
	{
		strcpy (BackupText, "Change Thing Arguments");
		for (cur = Selected; cur; cur = cur->next)
			Things[cur->objnum].arg[Arg-1] = val;
		if (CurObject >= 0)
		{
			Things[CurObject].arg[Arg-1] = val;
			return REDRAW_ALL;
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingType(BCINT CurObject, SelPtr Selected)
{
	int val;

	ShowSprite = TRUE;
	val = SelectThingType();
	ShowSprite = FALSE;
	if(val >= 0)
	{
		SelPtr cur;
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Type");
		for(cur = Selected; cur; cur = cur->next)
		{
			if(cur->objnum != CurObject)  
				Things[ cur->objnum].type = val;
		}
		if (CurObject >= 0)
			Things[ CurObject].type = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingFlags(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val, foo, extra;
	Bool didBackup = FALSE;

	MenuDefault = 0;
	do {
		MadeChanges = FALSE;
		if (CurObject >= 0)
			foo = CurObject;
		else
			foo = Selected->objnum;
		extra = GetThingExtra (Things[foo].type);
		val = DisplayMenu( -1, -1, "Toggle the flags:",
			  GetThingFlag( foo, 1, extra),
			  GetThingFlag( foo, 2, extra),
			  GetThingFlag( foo, 3, extra),
			  GetThingFlag( foo, 4, extra),
			  GetThingFlag( foo, 5, extra),
			  GetThingFlag( foo, 6, extra),
			  GetThingFlag( foo, 7, extra),
			  GetThingFlag( foo, 8, extra),
			  GetThingFlag( foo, 9, extra),
			  GetThingFlag( foo, 10, extra),
			  GetThingFlag( foo, 11, extra),
			  "-",
			  "Enter a Decimal Value",
			  "-",
			  "Exit Menu",
			  NULL);
		if (val >= 1 && val <= 11)
		{
			if (!didBackup)
			{
				didBackup = TRUE;
				Backup (BTHINGS);
				strcpy (BackupText, "Change Thing Flags");
			}
			for (cur = Selected; cur; cur = cur->next) 
				if(cur->objnum != CurObject)  
					Things[ cur->objnum].flags ^= 1 << (val - 1);
			if (CurObject >= 0)
				Things[ CurObject].flags ^= 1 << (val - 1);
			MadeChanges = TRUE;
			MenuDefault = val - 1;
		}
		else if (val == 13)
		{										   
			MenuDefault = 12;
			val = InputIntegerValue( -1, -1, 0, 32767, Things[ foo].flags);
			if (val >= 0)
			{
				if (!didBackup)
				{
					didBackup = TRUE;
					Backup (BTHINGS);
					strcpy (BackupText, "Change Thing Flags");
				}
				for (cur = Selected; cur; cur = cur->next) 
					if(cur->objnum != CurObject)  
						Things[ cur->objnum].flags = val;
				if (CurObject >= 0)
					Things[ CurObject].flags = val;
				MadeChanges = TRUE;
			}
		}
		else
		{
			MenuDefault = 0;
			return REDRAW_ALL;
		}
	} while (MadeChanges == TRUE);
	MenuDefault = 0;
	return REDRAW_ALL;
}

BCINT FunctionThingAngle(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;
	int olddefault = MenuDefault;
	MenuDefault = ((360 - Things[Selected->objnum].angle + 90) / 45) & 7;
	switch (DisplayMenu(-1, -1, "Select Angle",
						"North",
						"NorthEast",
						"East",
						"SouthEast",
						"South",
						"SouthWest",
						"West",
						"NorthWest",
						"-",
						"Enter a Decimal Value",
						NULL))
	{
	case 1:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To North");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 90;
		MadeChanges = TRUE;
		break;
	case 2:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To NorthEast");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 45;
		MadeChanges = TRUE;
		break;
	case 3:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To East");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 0;
		MadeChanges = TRUE;
		break;
	case 4:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To SouthEast");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 315;
		MadeChanges = TRUE;
		break;
	case 5:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To South");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 270;
		MadeChanges = TRUE;
		break;
	case 6:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To SouthWest");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 225;
		MadeChanges = TRUE;
		break;
	case 7:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To West");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 180;
		MadeChanges = TRUE;
		break;
	case 8:
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Angle To NorthWest");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].angle = 135;
		MadeChanges = TRUE;
		break;
	case 10:
		val = InputIntegerValue( -1, -1, 0, 359, Things[ Selected->objnum].angle);
		if (val >= 0)
		{
			Backup (BTHINGS);
			strcpy (BackupText, "Change Thing Angle");
			for (cur = Selected; cur; cur = cur->next)
				Things[ cur->objnum].angle = val;
			MadeChanges = TRUE;
		}
		break;
	}
	MenuDefault = olddefault;
	return REDRAW_ALL;
}

BCINT FunctionThingXPos(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	val = InputIntegerValue( -1, -1, MapMinX, MapMaxX, Things[ Selected->objnum].xpos);
	if (val >= MapMinX)
	{
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing X Position");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].xpos = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionThingYPos(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	val = InputIntegerValue( -1, -1, MapMinY, MapMaxY, Things[ Selected->objnum].ypos);
	if (val >= MapMinY)
	{
		Backup (BTHINGS);
		strcpy (BackupText, "Change Thing Y Position");
		for (cur = Selected; cur; cur = cur->next)
			Things[ cur->objnum].ypos = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}



/*********************/
/* LINEDEF FUNCTIONS */
/*********************/

BCINT FunctionLineDefEnum(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	char *enumName;
	SelPtr cur;
	int val;

	if (CurObject >= 0)
		enumName = GetLineDefEnums (LineDefs[CurObject].special)[Arg-1];
	else
		enumName = GetLineDefEnums (LineDefs[Selected->objnum].special)[Arg-1];

	val = SelectEnumValue(enumName);
	if (val >= 0)
	{
		sprintf (BackupText, "Change LineDef %s Value", enumName);
		for (cur = Selected; cur; cur = cur->next)
			LineDefs[cur->objnum].arg[Arg-1] = val;
		if (CurObject >= 0)
		{
			LineDefs[CurObject].arg[Arg-1] = val;
			return REDRAW_ALL;
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefHexenAngle(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur;
	int val;

	val = SelectHexenAngle();
	if (val >= 0) {
		strcpy (BackupText, "Change LineDef Angle Argument");
		for (cur = Selected; cur; cur = cur->next)
			LineDefs[cur->objnum].arg[Arg-1] = val;
		if (CurObject >= 0)
		{
			LineDefs[CurObject].arg[Arg-1] = val;
			return REDRAW_ALL;
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefNegative(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur;
	int val;

	val = SelectNegative();
	if (val >= 0) {
		strcpy (BackupText, "Change LineDef Negative Argument");
		for (cur = Selected; cur; cur = cur->next)
			LineDefs[cur->objnum].arg[Arg-1] = val;
		if (CurObject >= 0)
		{
			LineDefs[CurObject].arg[Arg-1] = val;
			return REDRAW_ALL;
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefSpawnType(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur;
	int val;

	ShowSprite = TRUE;
	val = SelectSpawnType();
	ShowSprite = FALSE;
	if (val >= 0) {
		strcpy (BackupText, "Change LineDef Spawn Type");
		for (cur = Selected; cur; cur = cur->next)
			LineDefs[cur->objnum].arg[Arg-1] = val;
		if (CurObject >= 0)
		{
			LineDefs[CurObject].arg[Arg-1] = val;
			return REDRAW_ALL;
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefArg(BCINT CurObject, SelPtr Selected, BCINT Arg)
{
	SelPtr cur = Selected;
	int val = -1;

	GetCoords();
	if (CurObject >= 0)
		val = InputIntegerValuePlain(90, MaxY - 76 + Arg * 10, 0, 255, LineDefs[ CurObject].arg[Arg-1]);
	else
		val = InputIntegerValue(-1, -1, 0, 255, LineDefs[cur->objnum].arg[Arg-1]);
	if (val >= 0)
	{
		strcpy (BackupText, "Change LineDef Arguments");
		for (cur = Selected; cur; cur = cur->next)
			LineDefs[cur->objnum].arg[Arg-1] = val;
		if (CurObject >= 0)
		{
			LineDefs[CurObject].arg[Arg-1] = val;
			return REDRAW_ALL;
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefTrigger(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	val = DisplayMenu( -1, -1, "Choose Trigger Type:",
		"Player Crosses",
		"Player Uses",
		"Monster Crosses",
		"Projectile Hits",
		"Player Pushes",
		"Projectile Crosses",
		"Player Uses (Passthru)",
		"Reserved", NULL);
	if (val > 0)
	{
		val = (val - 1) << 10;
		for (cur = Selected; cur; cur = cur->next)
		{
			if (cur->objnum != CurObject)
			{
				LineDefs[cur->objnum].flags &= ~0x1c00;
				LineDefs[cur->objnum].flags |= val;
			}
		}
		if (CurObject >= 0) {
			LineDefs[CurObject].flags &= ~0x1c00;
			LineDefs[CurObject].flags |= val;
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefXoffset(BCINT CurObject, SelPtr Selected, BCINT SideDef)
{
	SelPtr cur;
	int val;
	int sd;

	GetCoords();
	if (SideDef == 1) {
		sd = LineDefs[ CurObject].sidedef1;
		val = InputIntegerValuePlain(381, MaxY - 56, -2048, 2048, SideDefs[ sd].xoff);
	}
	else {
		sd = LineDefs[ CurObject].sidedef2;
		val = InputIntegerValuePlain(572, MaxY - 56, -2048, 2048, SideDefs[ sd].xoff);
	}

	if (val >= -2048) {
		Backup (BLINEDEFS);
		strcpy (BackupText, "Change X Offset");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject) { 
				if (SideDef == 1)
					sd = LineDefs[ cur->objnum].sidedef1;
				else
					sd = LineDefs[ cur->objnum].sidedef2;
				SideDefs[sd].xoff = val;
			} 
		}
		if (SideDef == 1)
			sd = LineDefs[CurObject].sidedef1;
		else
			sd = LineDefs[CurObject].sidedef2;
		SideDefs[sd].xoff = val;
	}
	MadeChanges = TRUE;
	return REDRAW_ALL;
}

BCINT FunctionLineDefYoffset(BCINT CurObject, SelPtr Selected, BCINT SideDef)
{
	SelPtr cur;
	int val;
	int sd;

	GetCoords();
	if (SideDef == 1) {
		sd = LineDefs[ CurObject].sidedef1;
		val = InputIntegerValuePlain(381, MaxY - 46, -2048, 2048, SideDefs[ sd].yoff);
	}
	else {
		sd = LineDefs[ CurObject].sidedef2;
		val = InputIntegerValuePlain(572, MaxY - 46, -2048, 2048, SideDefs[ sd].yoff);
	}

	if (val >= -2048) {
		Backup (BLINEDEFS);
		strcpy (BackupText, "Change Y Offset");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject) { 
				if (SideDef == 1)
					sd = LineDefs[ cur->objnum].sidedef1;
				else
					sd = LineDefs[ cur->objnum].sidedef2;
				SideDefs[sd].yoff = val;
			} 
		}
		if (SideDef == 1)
			sd = LineDefs[CurObject].sidedef1;
		else
			sd = LineDefs[CurObject].sidedef2;
		SideDefs[sd].yoff = val;
	}
	MadeChanges = TRUE;
	return REDRAW_ALL;
}

BCINT FunctionLineDefSectorRef(BCINT CurObject, SelPtr Selected, BCINT SideDef)
{
	SelPtr cur;
	int val;
	int sd;

	GetCoords();
	if (SideDef == 1) {
		sd = LineDefs[ CurObject].sidedef1;
		val = InputIntegerValuePlain(381, MaxY - 26, -1, NumSectors + 1, SideDefs[ sd].sector);
	}
	else {
		sd = LineDefs[ CurObject].sidedef2;
		val = InputIntegerValuePlain(572, MaxY - 26, -1, NumSectors + 1, SideDefs[ sd].sector);
	}

	if (val >= -1) {
		Backup (BLINEDEFS | BSIDEDEFS);
		strcpy (BackupText, "Change SideDef Sector Ref");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject) { 
				if (SideDef == 1) {
					sd = LineDefs[ cur->objnum].sidedef1;
					if (val == -1)
						LineDefs[cur->objnum].sidedef1 = val;
				}
				else {
					sd = LineDefs[ cur->objnum].sidedef2;
					if (val == -1)
						LineDefs[cur->objnum].sidedef2 = val;
				}
				SideDefs[sd].sector = val;
			} 
		}
		if (SideDef == 1) {
			sd = LineDefs[CurObject].sidedef1;
			if (val == -1)
				LineDefs[CurObject].sidedef1 = val;
		}
		else {
			sd = LineDefs[CurObject].sidedef2;
			if (val == -1)
				LineDefs[CurObject].sidedef2 = val;
		}
		SideDefs[sd].sector = val;
	}
	MadeChanges = TRUE;
	return REDRAW_ALL;
}

BCINT FunctionLineDefFlags(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val, foo;

	MenuDefault = 0;
	do {
		MadeChanges = FALSE;
		if (CurObject >= 0)
			foo = CurObject;
		else
			foo = Selected->objnum;
		val = DisplayMenu( -1, -1, "Toggle the flags:",
			  GetTaggedLineDefFlag( foo, 1),
			  GetTaggedLineDefFlag( foo, 2),
			  GetTaggedLineDefFlag( foo, 3),
			  GetTaggedLineDefFlag( foo, 4),
			  GetTaggedLineDefFlag( foo, 5),
			  GetTaggedLineDefFlag( foo, 6),
			  GetTaggedLineDefFlag( foo, 7),
			  GetTaggedLineDefFlag( foo, 8),
			  GetTaggedLineDefFlag( foo, 9),
			  GetTaggedLineDefFlag( foo, 10),
			  GetTaggedLineDefFlag( foo, 14),
			  GetTaggedLineDefFlag( foo, 16),
			  "-",
			  "Enter a Decimal Value",
			  "-",
			  "Exit Menu",
			  NULL);
		if (val >= 1 && val <= 12) {
			if (val == 11)
				val = 14;
			else if (val == 12)
				val = 16;
			strcpy (BackupText, "Change LineDef Flags");

			for (cur = Selected; cur; cur = cur->next) 
				if(cur->objnum != CurObject)  
					LineDefs[ cur->objnum].flags ^= 0x01 << (val - 1);
			if (CurObject >= 0)
				LineDefs[ CurObject].flags ^= 0x01 << (val - 1);
			MadeChanges = TRUE;
			if (val == 14)
				val = 11;
			else if (val == 16)
				val = 12;
			MenuDefault = val - 1;
		}
		else if (val == 14) {
			MenuDefault = 13;
			val = InputIntegerValue( -1, -1, 0, 32767, LineDefs[ CurObject].flags);
			if (val >= 0) {
				strcpy (BackupText, "Change LineDef Flags");
				for (cur = Selected; cur; cur = cur->next) 
					if(cur->objnum != CurObject)  
						LineDefs[ cur->objnum].flags = val;
				if (CurObject >= 0)
					LineDefs[ CurObject].flags = val;
				MadeChanges = TRUE;
			}
		}
	} while (MadeChanges == TRUE);
	MenuDefault = 0;
	return REDRAW_ALL;
}

BCINT FunctionLineDefSpecial(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	ld_class *c;
	ld_type *t;
	char *menuarr[MENUARRAYMAX];
	BCINT dummy[MENUARRAYMAX];
	int i, val;
	Bool input_integer = FALSE;
	
	c = Linedef_classes;
	for(i = 0; (c && i < MENUARRAYMAX-2); i++) {
		menuarr[i] = c->name;
		c = c->next;
	}
	menuarr[i++] = "-";
	menuarr[i++] = "Enter a Decimal Value";
	
	val = DisplayMenuArray( -1, -1, "Choose a Special Class:",
						   i, NULL, menuarr, dummy);
	if(val == 0)
		val = -1;
	
	if(i == val) {
		input_integer = TRUE;
		val = InputIntegerValue(-1, -1, 0, 255, 0);
	}
	
	if(val >= 0)
	{
		if(!input_integer)
		{
			c = Linedef_classes;
			while(--val)
				c = c->next;
			/* now c points to the class we are
			   going to display a submenu for */
			
			t = c->types;
			for(i = 0; (t && i < MENUARRAYMAX); t = t->next) {
				menuarr[i++] = t->longname;
			}
			
			if(i == 1) {
				val = c->types->type; 
				strcpy (BackupText, "Change Special Type");
				Backup (BLINEDEFS);
				for (cur = Selected; cur; cur = cur->next) {
					if(cur->objnum != CurObject)  
						LineDefs[ cur->objnum].special = val;
				}
				if (CurObject >= 0)
					LineDefs[ CurObject].special = val;
				MadeChanges = TRUE;
			}
			else {
				val = DisplayMenuArray(-1, -1, "Choose a Special Type:",
									   i, NULL, menuarr, dummy);
				if(val == 0)
					val = -1;
			}
		}
		
		if (i >= 2 && val >= 0)
		{
			strcpy (BackupText, "Change Special Type");
			Backup (BLINEDEFS);
			if(!input_integer)
			{
				t = c->types;
				while(--val)
					t = t->next;
				val = t->type;
			}
			
			for (cur = Selected; cur; cur = cur->next)
			{
				if(cur->objnum != CurObject)  
					LineDefs[ cur->objnum].special = val;
			}
			if (CurObject >= 0)
				LineDefs[ CurObject].special = val;
			MadeChanges = TRUE;
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefFlag(BCINT CurObject, SelPtr Selected, BCINT Flag)
{
	SelPtr cur;

	Backup (BTHINGS);
	strcpy (BackupText, "Change LineDef Flags");
	for (cur = Selected; cur; cur = cur->next)
		if(cur->objnum != CurObject) 
			LineDefs[ cur->objnum].flags ^= 0x01 << Flag;
	if (CurObject >= 0)
		LineDefs[ CurObject].flags ^= 0x01 << Flag;
	MadeChanges = TRUE;
	return REDRAW_ALL;
}

// [RH] Change user flags for a special argument

BCINT FunctionLineDefArgFlags(BCINT CurObject, SelPtr Selected, int arg)
{
	char *flagsName;
	enum_type *e;
	char title[100];
	SelPtr cur;
	int val, foo, mask;

	if (CurObject >= 0)
		foo = CurObject;
	else
		foo = Selected->objnum;

	flagsName = GetLineDefEnums (LineDefs[foo].special)[arg-1];
	e = FindEnum (flagsName);
	if (e == NULL)
	{
		return FunctionLineDefArg (CurObject, Selected, arg);
	}

	sprintf (title, "Toggle %s Flags:", flagsName);
	val = TwiddleFlagsMenu (e->keys, title, LineDefs[foo].arg[--arg], &mask);
	if (mask == 0)
	{ // Set directly
		sprintf (BackupText, "Set LineDef %s Flags", flagsName);
		val &= 255;
		for (cur = Selected; cur; cur = cur->next) 
			LineDefs[ cur->objnum].arg[arg] = val;
		if (CurObject >= 0)
			LineDefs[ CurObject].arg[arg] = val;
	}
	else if (val != 0 || mask != ~0)
	{ // xor with existing flags
		sprintf (BackupText, "Change LineDef %s Flags", flagsName);
		for (cur = Selected; cur; cur = cur->next) 
			if(cur->objnum != CurObject)  
				LineDefs[ cur->objnum].arg[arg] = (LineDefs[ cur->objnum].arg[arg] & mask) ^ val;
		if (CurObject >= 0)
			LineDefs[ CurObject].arg[arg] = (LineDefs[ CurObject].arg[arg] & mask) ^ val;
	}
	MadeChanges = (val != 0 || mask != ~0);
	return REDRAW_ALL;
}

BCINT FunctionLineDefDeleteJoin(BCINT CurObject, SelPtr Selected)
{
	Backup (~BTHINGS);
	strcpy (BackupText, "Delete LineDefs and Join Sectors");
	DeleteLineDefsJoinSectors ( &Selected);
	return REDRAW_ALL; 
}

BCINT FunctionLineDefSplitAdd(BCINT CurObject, SelPtr Selected)
{
	if (Selected == NULL || ( Selected)->next == NULL || ( Selected)->next->next != NULL)
	{
		DEU_Beep();
		Notify( -1, -1, "You Must Select Exactly Two LineDefs", NULL);
		return REDRAW_ALL;
	}
	else
	{
		Backup (~BTHINGS);
		strcpy (BackupText, "Split LineDefs And Add Sector");
		SplitLineDefsAndSector( ( Selected)->objnum, ( Selected)->next->objnum);
		return REDRAW_ALL;
	}
}

//jff Split Donut function added

BCINT FunctionConnectLineDefsSplitDonut(BCINT CurObject, SelPtr Selected)
{
	if (!Selected || ( Selected)->next == NULL || ( Selected)->next->next != NULL)
	{
		DEU_Beep();
		Notify( -1, -1, "You Must Select Exactly Two LineDefs", NULL);
		return REDRAW_ALL;
	}
	else
	{
		Backup (~BTHINGS);
		strcpy (BackupText, "Connect LineDefs And Split Donut");
		ConnectLineDefsSplitDonut( ( Selected)->objnum, ( Selected)->next->objnum);
		return REDRAW_ALL;
	}
}

//jff Make Hallway function added

BCINT FunctionConnectLineDefsMakeHallway(BCINT CurObject, SelPtr Selected)
{
	if (!Selected || ( Selected)->next == NULL || ( Selected)->next->next != NULL)
	{
		DEU_Beep();
		Notify( -1, -1, "You Must Select Exactly Two LineDefs", NULL);
		return REDRAW_ALL;
	}
	else
	{
		Backup (~BTHINGS);
		strcpy (BackupText, "Connect LineDefs And Make Hallway");
		ConnectLineDefsMakeHallway( ( Selected)->objnum, ( Selected)->next->objnum);
		return REDRAW_ALL;
	}
}

BCINT FunctionRenumberLineDefsLowest(BCINT CurObject, SelPtr Selected)
{
	SelPtr lp,rp;
 	int inspoint = 0;
	int l,i;
	struct LineDef l0;

	Backup (BLINEDEFS);

	lp = Selected;
	if (!lp && CurObject>=0)
	{
		l = CurObject;
		l0 = LineDefs[l];
		for (i=l-1;i>=0;i--)
			LineDefs[i+1] = LineDefs[i];
		LineDefs[0] = l0;
		CurObject = 0;
	}
	else
	{
		while (lp)
		{
			l = lp->objnum;
			l0 = LineDefs[l];
			for (i=l-1;i>=inspoint;i--)
				LineDefs[i+1] = LineDefs[i];
			LineDefs[inspoint] = l0;
			rp = Selected;
			while (rp)
			{
				if (rp->objnum>=inspoint && rp->objnum<l)
					rp->objnum = rp->objnum+1;
				rp = rp->next;
			}
			lp->objnum = inspoint++;
			lp = lp->next;

		}
	}

	sprintf (BackupText, "Renumber Linedefs Lowest");
	return REDRAW_ALL;
}

BCINT FunctionLineDefFlipSideDefs(BCINT CurObject, SelPtr Selected)
{
	Backup (BLINEDEFS | BSIDEDEFS);
	strcpy (BackupText, "Flip SideDefs");
	if (CurObject && !Selected) {
		struct SelectionList cur;
		cur.objnum = CurObject;
		cur.next = NULL;
		FlipLineDefs(&cur, TRUE);
	}
	FlipLineDefs( Selected, TRUE);
	return REDRAW_ALL;
}

BCINT FunctionLineDefSwapSideDefs(BCINT CurObject, SelPtr Selected)
{
	Backup (BLINEDEFS | BSIDEDEFS);
	strcpy (BackupText, "Swap SideDefs");
	if (CurObject && !Selected) {
		struct SelectionList cur;
		cur.objnum = CurObject;
		cur.next = NULL;
		FlipLineDefs(&cur, FALSE);
	}
	FlipLineDefs( Selected, FALSE);
	return REDRAW_ALL; 
}

BCINT FunctionLineDefBrowseWallTextures(BCINT CurObject, SelPtr Selected, BCINT SideDef, BCINT Texture)
{
	SelPtr cur;
	int val = 0;

	if (SideDef == 1 && Texture == 1)
		val = BrowseWalls(SideDefs[LineDefs[CurObject].sidedef1].tex1);
	if (SideDef == 1 && Texture == 2)
		val = BrowseWalls(SideDefs[LineDefs[CurObject].sidedef1].tex2);
	if (SideDef == 1 && Texture == 3)
		val = BrowseWalls(SideDefs[LineDefs[CurObject].sidedef1].tex3);
	if (SideDef == 2 && Texture == 1)
		val = BrowseWalls(SideDefs[LineDefs[CurObject].sidedef2].tex1);
	if (SideDef == 2 && Texture == 2)
		val = BrowseWalls(SideDefs[LineDefs[CurObject].sidedef2].tex2);
	if (SideDef == 2 && Texture == 3)
		val = BrowseWalls(SideDefs[LineDefs[CurObject].sidedef2].tex3);
	if (val >= 0) {
		Backup (BSIDEDEFS | BLINEDEFS);
		strcpy (BackupText, "Change Wall Texture");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject) {
				if (SideDef == 1 && Texture == 1)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex1, WTexture[val], 8);
				else if (SideDef == 1 && Texture == 2)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex2, WTexture[val], 8);
				else if (SideDef == 1 && Texture == 3)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex3, WTexture[val], 8);
				else if (SideDef == 2 && Texture == 1)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex1, WTexture[val], 8);
				else if (SideDef == 2 && Texture == 2)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex2, WTexture[val], 8);
				else if (SideDef == 2 && Texture == 3)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex3, WTexture[val], 8);
			}
		}
		if(CurObject >= 0) {
			if (SideDef == 1 && Texture == 1)
				strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex1, WTexture[val], 8);
			else if (SideDef == 1 && Texture == 2)
				strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex2, WTexture[val], 8);
			else if (SideDef == 1 && Texture == 3)
				strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex3, WTexture[val], 8);
			else if (SideDef == 2 && Texture == 1)
				strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex1, WTexture[val], 8);
			else if (SideDef == 2 && Texture == 2)
				strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex2, WTexture[val], 8);
			else if (SideDef == 2 && Texture == 3)
				strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex3, WTexture[val], 8);
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefWallTextures(BCINT CurObject, SelPtr Selected, BCINT SideDef, BCINT Texture)
{
	SelPtr cur;
	char texname[9];

	texname[8] = '\0';

	if (SideDef == 1 && Texture == 1)
		strncpy(texname, SideDefs[LineDefs[CurObject].sidedef1].tex1, 8);
	else if (SideDef == 1 && Texture == 2)
		strncpy(texname, SideDefs[LineDefs[CurObject].sidedef1].tex2, 8);
	else if (SideDef == 1 && Texture == 3)
		strncpy(texname, SideDefs[LineDefs[CurObject].sidedef1].tex3, 8);
	else if (SideDef == 2 && Texture == 1)
		strncpy(texname, SideDefs[LineDefs[CurObject].sidedef2].tex1, 8);
	else if (SideDef == 2 && Texture == 2)
		strncpy(texname, SideDefs[LineDefs[CurObject].sidedef2].tex2, 8);
	else if (SideDef == 2 && Texture == 3)
		strncpy(texname, SideDefs[LineDefs[CurObject].sidedef2].tex3, 8);

	ChooseWallTexture( -1, -1, "Choose a Wall Texture", NumWTexture, WTexture, texname);
	if (strlen(texname) > 0) {
		Backup (BSIDEDEFS | BLINEDEFS);
		strcpy (BackupText, "Change Wall Texture");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject)  {
				if (SideDef == 1 && Texture == 1)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex1, texname, 8);
				else if (SideDef == 1 && Texture == 2)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex2, texname, 8);
				else if (SideDef == 1 && Texture == 3)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex3, texname, 8);
				else if (SideDef == 2 && Texture == 1)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex1, texname, 8);
				else if (SideDef == 2 && Texture == 2)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex2, texname, 8);
				else if (SideDef == 2 && Texture == 3)
					strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex3, texname, 8);
			}
		}
		if(CurObject >= 0) {
			if (SideDef == 1 && Texture == 1)
				strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex1, texname, 8);
			else if (SideDef == 1 && Texture == 2)
				strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex2, texname, 8);
			else if (SideDef == 1 && Texture == 3)
				strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex3, texname, 8);
			else if (SideDef == 2 && Texture == 1)
				strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex1, texname, 8);
			else if (SideDef == 2 && Texture == 2)
				strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex2, texname, 8);
			else if (SideDef == 2 && Texture == 3)
				strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex3, texname, 8);
		}
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}

BCINT FunctionLineDefWallTexture(BCINT CurObject, SelPtr Selected, char *Name, BCINT SideDef, BCINT Texture)
{
	SelPtr cur;
	char texname[9];

	texname[8] = '\0';
	strncpy(texname, Name, 8);

	Backup (BSIDEDEFS);
	strcpy (BackupText, "Change Wall Texture");
	for (cur = Selected; cur; cur = cur->next) {
		if(cur->objnum != CurObject) {
			if (SideDef == 1 && Texture == 1)
				strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex1, texname, 8);
			else if (SideDef == 1 && Texture == 2)
				strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex2, texname, 8);
			else if (SideDef == 1 && Texture == 3)
				strncpy(SideDefs[LineDefs[cur->objnum].sidedef1].tex3, texname, 8);
			else if (SideDef == 2 && Texture == 1)
				strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex1, texname, 8);
			else if (SideDef == 2 && Texture == 2)
				strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex2, texname, 8);
			else if (SideDef == 2 && Texture == 3)
				strncpy(SideDefs[LineDefs[cur->objnum].sidedef2].tex3, texname, 8);
		}
	}
	if(CurObject >= 0) {
		if (SideDef == 1 && Texture == 1)
			strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex1, texname, 8);
		else if (SideDef == 1 && Texture == 2)
			strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex2, texname, 8);
		else if (SideDef == 1 && Texture == 3)
			strncpy(SideDefs[LineDefs[CurObject].sidedef1].tex3, texname, 8);
		else if (SideDef == 2 && Texture == 1)
			strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex1, texname, 8);
		else if (SideDef == 2 && Texture == 2)
			strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex2, texname, 8);
		else if (SideDef == 2 && Texture == 3)
			strncpy(SideDefs[LineDefs[CurObject].sidedef2].tex3, texname, 8);
	}
	MadeChanges = TRUE;
	return REDRAW_ALL;
}

/********************/
/* SECTOR FUNCTIONS */
/********************/

BCINT FunctionSectorType(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	sector_class *c;
	sector_type *t;
	char *menuarr[MENUARRAYMAX];
	BCINT dummy[MENUARRAYMAX];
	int i, val;
	Bool input_integer = FALSE;

	c = Sector_classes;
	for(i = 0; (c && i < MENUARRAYMAX); i++)
	{
		menuarr[i] = c->name;
		c = c->next;
	}
	menuarr[i++] = "-";
	menuarr[i++] = "Enter a Decimal Value";
	
	val = -1;
	val = DisplayMenuArray( -1 , -1, "Choose a Sector Special:",
						   i, NULL, menuarr, dummy);
	
	if(val == 0)
		val = -1;
	
	if(i == val) {
		input_integer = TRUE;
		val = InputIntegerValue(-1, -1, 0, 255, Sectors[Selected->objnum].special & 255);
	}

	if(val >= 0) {
		if(!input_integer) {
			c = Sector_classes;
			while(--val)
				c = c->next;
			
			t = c->types;
			for(i = 0; (t && i < MENUARRAYMAX); i++) {
				menuarr[i] = t->longname;
				t = t->next;
			}
			
			if(i == 1) {
					val = c->types->type; 
					strcpy (BackupText, "Change Sector Special");
					Backup (BSECTORS);
					for (cur = Selected; cur; cur = cur->next) {
						if(cur->objnum != CurObject)  
							Sectors[cur->objnum].special = (Sectors[cur->objnum].special & ~255) | val;
					}
					if (CurObject >= 0)
						Sectors[CurObject].special = (Sectors[CurObject].special & ~255) | val;
					MadeChanges = TRUE;
			}
			else {
				val = -1;
				val = DisplayMenuArray(-1, -1, "Choose a Sector Special:",
									   i, NULL, menuarr, dummy);
				if(val == 0)
					val = -1;
			}
		}
		
		if (i >= 2 && val >= 0) {
			Backup (BSECTORS);
			strcpy (BackupText, "Change Sector Special");
			if(!input_integer) {
				t = c->types;
				while(--val)
					t = t->next;
				val = t->type;
			}
			
			for(cur = Selected; cur; cur = cur->next) {
				if(cur->objnum != CurObject)  
					Sectors[cur->objnum].special = (Sectors[cur->objnum].special & ~255) | val;
				MadeChanges = TRUE;
			}
			if (CurObject >= 0)
				Sectors[CurObject].special = (Sectors[CurObject].special & ~255) | val;
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionSectorFlags (BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	BCINT dummy[MENUARRAYMAX];
	int val, foo;
	Bool didBackup = FALSE;

	static char *flagnames[MENUARRAYMAX] =
	{
		"  No Damage",
		"  Damage 5",
		"  Damage 10",
		"  Damage 20",
		"-",
		"  Secret Area",
		"-",
		"  BOOM Friction Enabled",
		"  BOOM Wind Enabled",
		"-",
		"Enter a Decimal Value",
		"-",
		"Exit Menu"
	};
	
	MenuDefault = 0;

	while (1)
	{
		if (flagnames[MenuDefault][0] == '-')
			MenuDefault = 0;
		foo = (CurObject >= 0) ? CurObject : Selected->objnum;

		for (val = 0; val < 4; val++)
			flagnames[val][0] = ' ';
		flagnames[(Sectors[foo].special & 0x0300) >> 8][0] = '*';
		flagnames[5][0] = Sectors[foo].special & 0x0400 ? '*' : ' ';
		flagnames[7][0] = Sectors[foo].special & 0x0800 ? '*' : ' ';
		flagnames[8][0] = Sectors[foo].special & 0x1000 ? '*' : ' ';

		val = -1;
		val = DisplayMenuArray (-1 , -1, "Set Sector Flags:",
			13, NULL, flagnames, dummy);
		
		if (val <= 0)
			return REDRAW_ALL;
		else
		{
			int mask, or;

			switch (val)
			{
				case 1: mask = 0x0300; or = 0; break;
				case 2: mask = 0x0300; or = 0x0100; break;
				case 3: mask = 0x0300; or = 0x0200; break;
				case 4: mask = 0x0300; or = 0x0300; break;
				case 6: mask = 0x0400; or = 0xffff; break;
				case 8: mask = 0x0800; or = 0xffff; break;
				case 9: mask = 0x1000; or = 0xffff; break;
				case 11:
					or = InputIntegerValue (-1, -1, 0, 255, (Sectors[foo].special >> 8) & 0xff);
					if (or >= 0)
					{
						mask = 0xff00;
						or <<= 8;
					}
					else
					{
						mask = 0;
					}
					break;
				case 13:
					return REDRAW_ALL; break;

				default: mask = or = 0; break;
			}
			if (mask)
			{
				if (!didBackup)
				{
					didBackup = TRUE;
					Backup (BSECTORS);
					strcpy (BackupText, "Change Sector Flags");
				}
				if (or != 0xffff)
				{
					for (cur = Selected; cur; cur = cur->next)
					{
						if (cur->objnum != CurObject)
							Sectors[cur->objnum].special = (Sectors[cur->objnum].special & ~mask) | or;
					}
					if (CurObject >= 0)
						Sectors[CurObject].special = (Sectors[CurObject].special & ~mask) | or;
				}
				else
				{
					for (cur = Selected; cur; cur = cur->next)
					{
						if (cur->objnum != CurObject)
							Sectors[cur->objnum].special ^= mask;
					}
					if (CurObject >= 0)
						Sectors[CurObject].special ^= mask;
				}
				MadeChanges = TRUE;
			}
			MenuDefault = val-1;
		}
	}
}

BCINT FunctionSectorFloorHeight(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	GetCoords();
	if (CurObject >= 0)
		val = InputIntegerValuePlain(90, MaxY - 76, -16384, 16384, Sectors[ CurObject].floorh);
	else
		val = InputIntegerValue( -1, -1, -16384, 16384, Sectors[Selected->objnum].floorh);

	if (val >= -16384) {
		Backup (BSECTORS);
		strcpy (BackupText, "Change Floor Height");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject)  
				Sectors[ cur->objnum].floorh = val;
		}
		MadeChanges = TRUE;
		if (CurObject >= 0) {
			Sectors[ CurObject].floorh = val;
			return REDRAW_ALL;
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionSectorTag(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	GetCoords();

	val = InputIntegerValuePlain(90, MaxY - 36, 0, 32767, Sectors[ CurObject].tag);
	if (val >= 0) {
		Backup (BSECTORS);
		strcpy (BackupText, "Change Sector Tag");
		for (cur = Selected; cur; cur = cur->next)
			if(cur->objnum != CurObject)  
				Sectors[ cur->objnum].tag = val;
		Sectors[ CurObject].tag = val;
		MadeChanges = TRUE;
	}
	return REDRAW_ALL;
}


BCINT FunctionSectorCeilingHeight(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	GetCoords();
	if (CurObject >= 0)
		val = InputIntegerValuePlain(90, MaxY - 66, -16384, 16384, Sectors[ CurObject].ceilh);
	else
		val = InputIntegerValue( -1, -1, -16384, 16384, Sectors[ Selected->objnum].ceilh);

	if (val >= -16384) {
		Backup (BSECTORS);
		strcpy (BackupText, "Change Ceiling Height");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject)  
				Sectors[ cur->objnum].ceilh = val;
		}
		MadeChanges = TRUE;
		if (CurObject >= 0) {
			Sectors[ CurObject].ceilh = val;
			return REDRAW_ALL;
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionSectorLightLevel(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	GetCoords();
	if (CurObject >= 0)
		val = InputIntegerValuePlain(90, MaxY - 46, 0, 255, Sectors[ CurObject].light);
	else
		val = InputIntegerValue( -1, -1, 0, 255, Sectors[ Selected->objnum].light);

	if (val >= 0) {
		Backup (BSECTORS);
		strcpy (BackupText, "Change Light Level");
		for (cur = Selected; cur; cur = cur->next) {
			if(cur->objnum != CurObject)  
				Sectors[ cur->objnum].light = val;
		}
		MadeChanges = TRUE;
		if (CurObject >= 0) {
			Sectors[ CurObject].light = val;
			return REDRAW_ALL;
		}
	}
	return REDRAW_ALL;
}

BCINT FunctionSectorBrowseFloor(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	val = BrowseFlats(Sectors[CurObject].floort);
	if (val >= 0) {
		Backup (BSECTORS);
		strcpy (BackupText, "Change Floor Texture");
		for (cur = Selected; cur; cur = cur->next)
			if(cur->objnum != CurObject) 
				strncpy(Sectors[ cur->objnum].floort, FTexture[val], 8);
		MadeChanges = TRUE;
		if (CurObject >= 0)
			strncpy(Sectors[ CurObject].floort, FTexture[val], 8);
	}
	return REDRAW_ALL;
}

BCINT FunctionSectorBrowseCeiling(BCINT CurObject, SelPtr Selected)
{
	SelPtr cur;
	int val;

	val = BrowseFlats(Sectors[CurObject].ceilt);
	if (val >= 0) {
		Backup (BSECTORS);
		strcpy (BackupText, "Change Ceiling Texture");
		for (cur = Selected; cur; cur = cur->next)
			 if(cur->objnum != CurObject)  
				strncpy(Sectors[ cur->objnum].ceilt, FTexture[val], 8);
		MadeChanges = TRUE;
		if (CurObject >= 0)
			strncpy(Sectors[ CurObject].ceilt, FTexture[val], 8);
	}
	return REDRAW_ALL;
}

BCINT FunctionRenumberSectorsLowest(BCINT CurObject, SelPtr Selected)
{
	SelPtr lp,rp;
 	int inspoint = 0;
	int l,i;
	struct Sector l0;

	Backup (BSECTORS | BSIDEDEFS);

	lp = Selected;
	if (!lp && CurObject>=0)
	{
		l = CurObject;
		l0 = Sectors[l];
		for (i=l-1;i>=0;i--)
			Sectors[i+1] = Sectors[i];
		Sectors[0] = l0;
		for (i=0;i<NumSideDefs;i++)
			if (SideDefs[i].sector>=0 && SideDefs[i].sector<l)
				SideDefs[i].sector++;
			else if (SideDefs[i].sector==l)
				SideDefs[i].sector=0;
		CurObject = 0;
	}
	else
	{
		while (lp)
		{
			l = lp->objnum;
			l0 = Sectors[l];
			for (i=l-1;i>=inspoint;i--)
				Sectors[i+1] = Sectors[i];
			Sectors[inspoint] = l0;
			rp = Selected;
			while (rp)
			{
				if (rp->objnum>=inspoint && rp->objnum<l)
					rp->objnum = rp->objnum+1;
				rp = rp->next;
			}
			for (i=0;i<NumSideDefs;i++)
				if (SideDefs[i].sector>=inspoint && SideDefs[i].sector<l)
					SideDefs[i].sector++;
				else if (SideDefs[i].sector==l)
					SideDefs[i].sector=inspoint;

			lp->objnum = inspoint++;
			lp = lp->next;

		}
	}

	sprintf (BackupText, "Renumber Sectors Lowest");
	return REDRAW_ALL;
}

/********************/
/* VERTEX FUNCTIONS */
/********************/

BCINT FunctionVertexDeleteJoin(BCINT CurObject, SelPtr Selected)
{
	Backup (~BTHINGS);
	strcpy (BackupText, "Delete Vertexes and Join LineDefs");
	if (CurObject && !Selected)
	{
		struct SelectionList cur;
		cur.objnum = CurObject;
		cur.next = NULL;
		DeleteVerticesJoinLineDefs( &cur);
	}
	else
	{
		DeleteVerticesJoinLineDefs( Selected);
	}
	return REDRAW_ALL;
}

BCINT FunctionVertexSplitLineDef(BCINT CurObject, SelPtr Selected)
{
	Backup (BVERTEXES | BLINEDEFS | BSIDEDEFS);
	strcpy (BackupText, "Split LineDefs");
	if (CurObject>=0 && !Selected) {	/*JFF >= 0 so Linedef 0 will split */
		struct SelectionList cur;
		cur.objnum = CurObject;
		cur.next = NULL;
		SplitLineDefs(&cur);
	}
	SplitLineDefs( Selected);
	return REDRAW_ALL;
}

BCINT FunctionVertexMerge(BCINT CurObject, SelPtr *Selected)
{
	Backup (BVERTEXES | BLINEDEFS | BSIDEDEFS);
	strcpy (BackupText, "Merge Vertexes");
	MergeVertices( Selected);
	return REDRAW_ALL;
}

BCINT FunctionVertexSplitSector(BCINT CurObject, SelPtr Selected)
{
	if (( Selected)->next == NULL || ( Selected)->next->next != NULL) {
		DEU_Beep();
		Notify( -1, -1, "You Must Select Exactly Two Vertices", NULL);
		return REDRAW_ALL;
	}
	else {
		Backup (~BTHINGS);
		strcpy (BackupText, "Split Sector Between 2 Vertexes");
		SplitSector( ( Selected)->objnum, ( Selected)->next->objnum);
		return REDRAW_ALL;
	}
}
